//
//  ShowOrderResponse.h
//  pay
//
//  Created by Jasmin Suljic on 04/09/16.
//  Copyright © 2019 Monri Payments d.o.o. All rights reserved.
//

#import <Foundation/Foundation.h>

/**
 *  <order>
 <masked-pan>4314********9913</masked-pan>
 <cc-type>visa</cc-type>
 <eci>06</eci>
 <enrolled>N</enrolled>
 <pares-status nil="true"/>
 <amount type="integer">2000</amount>
 <currency>RSD</currency>
 <exchange-rate type="float">1.0</exchange-rate>
 <outgoing-amount type="integer">2000</outgoing-amount>
 <outgoing-currency>RSD</outgoing-currency>
 <number-of-installments nil="true"/>
 <approval-code>901216</approval-code>
 <reference-number>607113774308</reference-number>
 <response-code>0000</response-code>
 <acq-response-code>000</acq-response-code>
 <status>approved</status>
 <acquirer>ucbrs</acquirer>
 <created-at type="datetime">2016-03-11T12:35:59+01:00</created-at>
 </order>
 */

@interface ShowOrderResponse : NSObject
NS_ASSUME_NONNULL_BEGIN
@property(strong,nonatomic) NSString *maskedPan;
@property(strong,nonatomic) NSString *ccType;
@property(strong,nonatomic) NSString *eci;
@property(strong, nonatomic) NSString *enrolled;
@property(strong, nonatomic) NSString *currency;
@property int amount;
@property float exchangeRate;
@property int outgoingAmount;

@property(strong, nonatomic) NSString *approvalCode;
@property(strong, nonatomic) NSString *referenceNumber;
@property(strong, nonatomic) NSString *responseCode;
@property(strong, nonatomic) NSString *acqResponseCode;
@property(strong, nonatomic) NSString *status;
@property(strong, nonatomic) NSString *acquirer;
@property(strong, nonatomic) NSString *createdAt;

NS_ASSUME_NONNULL_END

@property(strong, nonatomic, nullable) NSString *paresStatus;
@property(strong, nonatomic, nullable) NSString *numberOfInstallments;


NS_ASSUME_NONNULL_BEGIN

-(id) init;
+(ShowOrderResponse *) fromJson:(NSDictionary *)jsonDict;
-(NSString *) description;

NS_ASSUME_NONNULL_END

@end
