//
//  AddPaymentMethodViewController.m
//  WebtehPaymentLib_Example
//
//  Created by Jasmin Suljic on 04/10/2018.
//  Copyright © 2018 Webteh. All rights reserved.
//

#import "AddPaymentMethodViewController.h"
#import "WebtehWebView.h"
#import "PgwApi.h"
#import "MerchantProvider.h"
#import "Merchant.h"

@interface AddPaymentMethodViewController ()
@property (weak, nonatomic) IBOutlet WebtehWebView *webtehWebView;
@property (weak, nonatomic) IBOutlet UIActivityIndicatorView *progressBar;

@end

@implementation AddPaymentMethodViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    NSArray *merchants = [MerchantProvider getAllMerchants];
    
    Merchant *merchant = [merchants objectAtIndex:0];
    
    // Do any additional setup after loading the view.
    PgwApi *api = [[PgwApi alloc] init:[merchant authenticationToken] isDebug:true];
    NSTimeInterval  today = [[NSDate date] timeIntervalSince1970];
    NSString *orderNumber = [NSString stringWithFormat:@"%.0f", today*1000];
    
    AddPaymentMethodLifecycleAdapter* adapter = [[AddPaymentMethodLifecycleAdapter alloc]init:self api:api merchantKey:[merchant merchantKey] orderNumber:orderNumber mode:TRANSACTION_SUCCESS_MODE];
    
    [_webtehWebView initialize:true timeout:5000];
    
    Customer *customer = [[Customer alloc] init:@"John Smith"
                                          email:@"test@test.com"
                                        address:@"Address"
                                    phoneNumber:@"+1-202-555-0138"
                                           city:@"Sarajevo"
                                         userId:@"userIdRandom"
                          ];

    AddPaymentMethodModel *model = [[AddPaymentMethodModel alloc] init:orderNumber orderInfo:@"order info" sign:@"021" client:@"add_payment_method" merchant:merchant customer:customer
                                    ];
    [_webtehWebView addPaymentMethod:adapter model:model];
}

-(void) showProgress{
    NSLog(@"showProgress");
    [self.progressBar startAnimating];
}
-(void) hideProgress{
    NSLog(@"hideProgress");
    [self.progressBar stopAnimating];
}

-(void) handleTransactionError: (ApiError *) error{
    NSLog(@"handleTransactionError %@", error);
    [self hideProgress];
}

-(void) logTransactionInfo:(NSString *)loggingInfo {
    NSLog(@"%@", loggingInfo);
}

-(void) addPaymentMethodSuccess: (PaymentMethod *) method {
    NSLog(@"addPaymentMethodSuccess %@", method);
}

@end
