//
//  PgwApiExampleViewController.m
//  pay
//
//  Created by Jasmin Suljic on 22/12/16.
//  Copyright © 2016 Webteh.hr. All rights reserved.
//

#import "PgwApiExampleViewController.h"
#import "PgwApi.h"
#import "TransactionErrorDetailed.h"
#import <AFNetworking/AFNetworking.h>
#import "PayModel.h"
#import "PaymentMethodResponse.h"
#import "MerchantProvider.h"
#import "Merchant.h"
#import "PaymentMethod.h"
#import "DeletePaymentMethodResponse.h"
#import "UpdatePaymentMethodResponse.h"

@interface PgwApiExampleViewController ()

@end

@implementation PgwApiExampleViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    
    NSArray *merchants = [MerchantProvider getAllMerchants];
    
    Merchant *merchant = [merchants objectAtIndex:0];
    
    // Do any additional setup after loading the view.
    PgwApi *api = [[PgwApi alloc] init:[merchant authenticationToken]  isDebug:true];
    
    if(_listPaymentMethod) {
        [api paymentMethods:@"test@test.com" success: ^(PaymentMethodResponse *model){
            
            for(PaymentMethod* element in [model paymentMethods]) {
                    NSLog(@"paymentMethod: %@ %@", [element pmAlias], [element cardType]);
            }
            
            NSLog(@"paymentMethods: %@", model);
        } failure:^(ApiError *error){
            NSLog(@"paymentMethods failure: %@", error);
        }];
    }else if(_deletePaymentMethod) {
        // "cxBrOFUsPIt4mqnmlIOFSqfdcYU9f4N7GEjtvBQ4", "User delete"
        
        [api deletePaymentMethod:@"cxBrOFUsPIt4mqnmlIOFSqfdcYU9f4N7GEjtvBQ4" reason: @"User delete" success: ^(DeletePaymentMethodResponse *model){
            NSLog(@"delete result: %@", [[model successResponse] status]);
        }];
    }
    else if(_updatePaymentMethod) {
        // hDAw8j21UfRK7-TUG5DK1s_llOrHLzqabI2-Or8t
        [api updatePaymentMethod:@"hDAw8j21UfRK7-TUG5DK1s_llOrHLzqabI2-Or8t" expiryDate: @"2020-10" success: ^(UpdatePaymentMethodResponse *model){
            NSLog(@"update result: %@", [[model successResponse] status]);
        }];
    } else {
        
    }
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}
- (IBAction)checkOrderBusinessError:(id)sender {
    PgwApi *api = [[PgwApi alloc] init:@"00001111222233330000111122223333" isDebug:true];
    
    ShowOrderModel *model = [[ShowOrderModel alloc] init];
    model.orderNumber = @"1486989100";
    
    // merchantKey + orderNumber
    model.digest = @"20f48b48ab14af427c9ca7730dad5d4074c36eac";
    
    [api checkOrder:model success:^(TransactionSuccess *model){
        // NSLog(@"checkOrder: %@", model);
        
    } failure:^(ApiError *error){
        // THIS SHOULD BE INVOKED
        NSLog(@"checkOrderFailure: %@", error);
    }];
}

- (IBAction)checkOrderSuccess:(id)sender {
    PgwApi *api = [[PgwApi alloc] init:@"00001111222233330000111122223333" isDebug:true];
    
            ShowOrderModel *model = [[ShowOrderModel alloc] init];
            model.orderNumber = @"1484635152";
    
            // merchantKey + orderNumber
            model.digest = [PayModel sha1:[NSString stringWithFormat:@"%@%@", @"TestKeyXULLyvgWyPJSwOHe", model.orderNumber]];
    
            [api checkOrder:model success:^(TransactionSuccess *model){
                NSLog(@"checkOrder: %@", model);
            } failure:^(ApiError *error){
                NSLog(@"checkOrderFailure: %@", error);
            }];
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
