//
//  AddPaymentMethodModel.m
//  WebtehPaymentLib
//
//  Created by Jasmin Suljic on 04/10/2018.
//

#import <Foundation/Foundation.h>
#import "Customer.h"
#import "Merchant.h"
#import "OrderDetails.h"
#import "AddPaymentMethodModel.h"
#import <Foundation/Foundation.h>
#import "InputResolver.h"
#import "PayModel.h"

@implementation AddPaymentMethodModel

-(id) init:(NSString * ) orderNumber
 orderInfo:(NSString * ) orderInfo
      sign:(NSString * ) sign
      client:(NSString * ) client
  merchant: (Merchant *) merchant
  customer: (Customer *) customer {
    _merchantId = [merchant merchantId];
    _client = client;
    _orderInfo = orderInfo;
    _orderNumber = orderNumber;
    _sign = sign;
    _clientSecret = [merchant clientSecret];
    _authToken = [merchant authenticationToken];
    _digest = [PayModel sha1:[NSString stringWithFormat:@"%@%@%@%@",
                              _merchantId,
                              _orderNumber,
                              _authToken,
                              _clientSecret
                              ]];
    _customer = customer;
    
    return [self init];
}


- (NSString *)toInput {
    NSMutableDictionary *data = [[NSMutableDictionary alloc] init];
    
    [data setValue:_client forKey:@"client"];
    [data setValue:_merchantId forKey:@"merchant_id"];
    [data setValue:_orderInfo forKey:@"order_info"];
    [data setValue:_orderNumber forKey:@"order_number"];
    [data setValue:_sign forKey:@"sign"];
    [data setValue:_clientSecret forKey:@"client_secret"];
    [data setValue:_authToken forKey:@"auth_token"];
    [data setValue:_digest forKey:@"digest"];
    
    if (_customer) {
        [data addEntriesFromDictionary:[_customer toDictionary]];
    }
    
    return [InputResolver encode:data];
}

@end
