//
//  ApiErrorException.m
//  pay
//
//  Created by Jasmin Suljic on 22/12/16.
//  Copyright © 2016 Webteh.hr. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "ApiErrorException.h"

@implementation ApiErrorException

-(id) init:(NSString *)error errors:(NSArray *)errors{
    self.errors = errors;
    if (error == nil && _errors.count >0) {
        _error = [_errors objectAtIndex:0];
    } else{
        _error = error;
    }
    
    return [self init];
}

-(NSString *) description{
    return [NSString stringWithFormat:@"error: %@, errors: %@", _error, _errors];
}

+(ApiErrorException *) fromJson: (NSDictionary *) jsonDict{
    
    if (!jsonDict) {
        return nil;
    }else{
        return [[ApiErrorException alloc] init:[jsonDict valueForKey:@"error"] errors:[jsonDict valueForKey:@"errors"]];
    }
}

@end
