//
//  PaymentMethod.m
//  WebtehPaymentLib
//
//  Created by Jasmin Suljic on 03/08/2018.
//

#import <Foundation/Foundation.h>
#import "PaymentMethod.h"
#import "TransactionSuccess.h"

@implementation PaymentMethod

- (id)init:(NSString *)pmAlias name:(NSString *)name userId:(NSString *)userId cardType:(NSString *)cardType maskedPan:(NSString *)maskedPan year:(NSString *)year month:(NSString *)month merchantId:(NSString *)merchantId expiresSoon: (bool) expiresSoon {
    _pmAlias = pmAlias;
    _name = name;
    _userId = userId;
    _cardType = cardType;
    _maskedPan = maskedPan;
    _year = year;
    _month = month;
    _merchantId = merchantId;
    _expiresSoon = expiresSoon;
    return [self init];
}

+(PaymentMethod *) fromJson:(NSDictionary *)data {
    PaymentMethod* pm = [[PaymentMethod alloc] init:[TransactionSuccess nilOrValue:[data valueForKey:@"id"]]
                                                 name:[TransactionSuccess nilOrValue:[data valueForKey:@"name"]]
                                               userId:[TransactionSuccess nilOrValue:[data valueForKey:@"user_id"]]
                                             cardType:[TransactionSuccess nilOrValue:[data valueForKey:@"card_type"]]
                                            maskedPan: [TransactionSuccess nilOrValue:[data valueForKey:@"masked_pan"]]
                                                 year:[TransactionSuccess nilOrValue:[data valueForKey:@"year"]]
                                                month:[TransactionSuccess nilOrValue:[data valueForKey:@"month"]]
                                           merchantId:[TransactionSuccess nilOrValue:[data valueForKey:@"merchant_id"]]
                                          expiresSoon:[[data valueForKey:@"expires_soon"] boolValue]];
    
    return pm;
}

@end
