//
//  PaymentMethodResponse.m
//  WebtehPaymentLib
//
//  Created by Jasmin Suljic on 03/08/2018.
//

#import <Foundation/Foundation.h>
#import "PaymentMethodResponse.h"
#import "PaymentMethod.h"

@implementation PaymentMethodResponse

- (id)init:(NSArray *)paymentMethods {
    _paymentMethods = paymentMethods;
    return [self init];
}

+ (PaymentMethodResponse *)fromJson:(NSDictionary *)data {
    NSArray *values = [data valueForKeyPath:@"payment_methods"];
    NSMutableArray *pm = [[NSMutableArray alloc] init];
    if (values == [NSNull null]) {
        return [[PaymentMethodResponse alloc]init: pm];
    } else {
        for (id element in values){
            if ([element isKindOfClass:[NSDictionary class]]) {
                [pm addObject:[PaymentMethod fromJson:element]];
            }
        }
    }
    
    return [[PaymentMethodResponse alloc]init: pm];
}

@end
