//
//  SharedLifecycleDelegate.h
//  WebtehPaymentLib
//
//  Created by Jasmin Suljic on 04/10/2018.
//

#import "ApiError.h"
#import <UIKit/UIKit.h>
#import <WebKit/WebKit.h>

@protocol SharedLifecycleDelegate <NSObject>

-(void) showProgress;

-(void) hideProgress;

-(void) handleTransactionError: (ApiError *) error;

@optional
/**
 - This method is invoked after timeout. To stop further delegate calls stop web view from loading.
 */
-(void) stopWebViewLoad;

-(void) threeDsLoaded;

-(void) threeDsSubmitted;

-(void) webViewDidStartLoad:(WKWebView *)webView;

-(void) webViewDidFinishLoad:(WKWebView *)webView;

-(void) logTransactionInfo:(NSString *)loggingInfo;

@end
