//
//  ShowOrderResponse.m
//  pay
//
//  Created by Jasmin Suljic on 04/09/16.
//  Copyright © 2019 Monri Payments d.o.o. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "ShowOrderResponse.h"

@implementation ShowOrderResponse

-(id)init{
    self = [super init];
    return self;
}

+(ShowOrderResponse *) fromJson:(NSDictionary *)jsonDict{
    
    if (!jsonDict) {
        return nil;
    }else{
        ShowOrderResponse *response = [[ShowOrderResponse alloc] init];
        
        response.maskedPan = [jsonDict valueForKey:@"masked_pan"];
        response.ccType = [jsonDict valueForKey:@"cc_type"];
        response.eci = [jsonDict valueForKey:@"eci"];
        response.enrolled = [jsonDict valueForKey:@"enrolled"];
        response.currency = [jsonDict valueForKey:@"currency"];
        
        response.amount = [[jsonDict valueForKey:@"amount"] intValue];
        response.exchangeRate = [[jsonDict valueForKey:@"exchange_rate"] floatValue];
        response.outgoingAmount = [[jsonDict valueForKey:@"outgoing_amount"] floatValue];
        
        response.approvalCode = [jsonDict valueForKey:@"approval_code"];
        response.referenceNumber = [jsonDict valueForKey:@"reference_number"];
        response.responseCode = [jsonDict valueForKey:@"response_code"];
        response.status = [jsonDict valueForKey:@"status"];
        response.acquirer = [jsonDict valueForKey:@"acquirer"];
        response.createdAt = [jsonDict valueForKey:@"created_at"];
        response.paresStatus = [jsonDict valueForKey:@"pares_status"];
        response.numberOfInstallments = [jsonDict valueForKey:@"number_of_installments"];
    
        return response;
    }
}

-(NSString *) description{
    return [NSString stringWithFormat:@"maskedPan %@, ccType %@, eci %@, enrolled %@, currency %@, amount %d, exchangeRate %f, outgoingAmount %d, approvalCode %@, referenceNumber %@, responseCode %@, status %@, acquirer %@, createdAt %@, paresStatus %@, numberOfInstallments %@",
            _maskedPan,
            _ccType,
            _eci,
            _enrolled,
            _currency,
            _amount,
            _exchangeRate,
            _outgoingAmount,
            
            _approvalCode,
            _referenceNumber,
            _responseCode,
            _status,
            _acquirer,
            _createdAt,
            _paresStatus,
            _numberOfInstallments];
}

@end
